#ifndef CFONTZ633_H
#define CFONTZ633_H

#include "lcd.h"

#define DEFAULT_CELL_WIDTH 6
#define DEFAULT_CELL_HEIGHT 8
#define DEFAULT_CONTRAST 560
#define DEFAULT_DEVICE "/dev/lcd"
#define DEFAULT_SPEED B19200
#define DEFAULT_BRIGHTNESS 100
#define DEFAULT_OFFBRIGHTNESS 0
#define DEFAULT_SIZE "16x2"
#define	DEFAULT_SIZE_CF633 "16x2"
#define	DEFAULT_SIZE_CF631 "20x2"
#define DEFAULT_TEMP_REPORT 0
#define DEFAULT_SYSLOG_SENSORS 0
#define	DEFAULT_DS18_NAME 	"T"	
#define	DEFAULT_WIDGET	 	1	// create a defalt widget or no
//#define	DEFAULT_DS18_TEMP 	-1000  // also used to denote a bad CRC  	
#define	DEFAULT_FAN_NAME 	"fan"	
#define	DEFAULT_FAN_AUTOREPORT 	0
#define	DEFAULT_FAN_POWER	100
#define	DEFAULT_FAN_LOG_POW	0
#define	DEFAULT_FAN_DIVISOR	2
#define	DEFAULT_FAN_D_LABEL	"RPM"
#define	DEFAULT_FAN_FAILSAFE	1
#define	DEFAULT_FAN_GLITCH	0
#define	DEFAULT_FAN_SENSOR	0	// 0=none; 1-32 possible	
#define	DEFAULT_FAN_BY_S_OFF	15   // (deg C  * 16) = ds18 "abstracto-units"
#define	DEFAULT_FAN_BY_S_100	25 
#define DEFAULT_FAN_SAFETY 	20   // this much warmer than defaults gets rejected
#define DEFAULT_FAN_A_SEC	10

MODULE_EXPORT int  CFontz633_init (Driver * drvthis, char *device);
MODULE_EXPORT void CFontz633_close (Driver * drvthis);
MODULE_EXPORT int  CFontz633_width (Driver * drvthis);
MODULE_EXPORT int  CFontz633_height (Driver * drvthis);
MODULE_EXPORT void CFontz633_clear (Driver * drvthis);
MODULE_EXPORT void CFontz633_flush (Driver * drvthis);
MODULE_EXPORT void CFontz633_string (Driver * drvthis, int x, int y, char string[]);
MODULE_EXPORT void CFontz633_chr (Driver * drvthis, int x, int y, char c);

MODULE_EXPORT void CFontz633_vbar (Driver * drvthis, int x, int y, int len, int promille, int options);
MODULE_EXPORT void CFontz633_hbar (Driver * drvthis, int x, int y, int len, int promille, int options);
MODULE_EXPORT void CFontz633_num (Driver * drvthis, int x, int num);
MODULE_EXPORT int  CFontz633_icon(Driver * drvthis, int x, int y, int icon);

MODULE_EXPORT void CFontz633_set_char (Driver * drvthis, int n, char *dat);

MODULE_EXPORT int  CFontz633_get_contrast (Driver * drvthis);
MODULE_EXPORT void CFontz633_set_contrast (Driver * drvthis, int contrast);
MODULE_EXPORT void CFontz633_backlight (Driver * drvthis, int on);

#endif
