/* This file should be release under the GPL,
 * However most of this is translation from the windows code
 * from Brent A. Crosby.
 * So I have to check with him.
 */
/*
 * ===========================================================================
 * 633 Test code for linux.
 * Copyright 2002, David GLAUDE
 * Partial copyright
 * 2001 Crystalfontz America, Inc. 
 * brent@crystalfontz.com
 * Written by Brent A. Crosby 
 * www.crystalfontz.com
 * ===========================================================================
 * 
 * 10/02/04
 * All new functionality added as a bloated elaboration of treat_packet
 * strikes me as mind-numbingly poor design. 
*/

#include "CFontz633io.h"
#include "lcd.h"
#include <unistd.h>
#include <stdio.h>
#include <syslog.h>
#include <time.h>

//#include "../clients.h"
#include "../screen.h"
#include "../screenlist.h"
#include "../widget.h"

/*#include <errno.h>*/
/*extern int errono;*/
#include <string.h>

# include <sys/time.h>


COMMAND_PACKET  incoming_command;

#define RECEIVEBUFFERSIZE    512
unsigned char  SerialReceiveBuffer[RECEIVEBUFFERSIZE];
int   ReceiveBufferHead;
int   ReceiveBufferTail;
int   ReceiveBufferTailPeek;


/*
 * KeyRing handeling function.
 * This separate the producer from the consumer.
 * It is just a small fifo of unsigned char.
 */

#define KEYRINGSIZE    16
unsigned char  KeyRing[KEYRINGSIZE];
int   KeyHead;
int   KeyTail;
const char *cf633_pack_names[64]= {"CF633_Ping_Command", "CF633_Get_Hardware_And_Firmware_Version", 
	"CF633_Write_User_Flash_Area", " CF633_Read_User_Flash_Area", "CF633_Store_Current_State_As_Boot_State",
	"CF633_Reboot", "CF633_Clear_LCD_Screen", "CF633_Set_LCD_Contents_Line_One", 
	"CF633_Set_LCD_Contents_Line_Two", "CF633_Set_LCD_Special_Character_Data",
	"CF633_Read_Eight_Bytes_of_LCD_Memory", "CF633_Set_LCD_Cursor_Position", "CF633_Set_LCD_Cursor_Style",
	"CF633_Set_LCD_Contrast", "CF633_Set_LCD_And_Keypad_Backlight", "CF633_Query_Last_Fan_Pulse_Count", 
	"CF633_Set_Up_Fan_Reporting", "CF633_Set_Fan_Power", "CF633_Read_DOW_Device_Information",
	"CF633_Set_Up_Temperature_Reporting", "CF633_Arbitrary_DOW_Transaction", 
	"CF633_Set_Up_Live_Fan_or_Temperature_Display", "CF633_Send_Command_Directly_to_the_LCD_Controller",
	"CF633_Configure_Key_Reporting", "CF633_Read_Keypad_Polled_Mode", "CF633_Set_Fan_Power_Failsafe",
	"CF633_Set_Fan_Tachometer_Glitch_Filter", "CF633_Query_Fan_Power_and_Failsafe_Mask",
	"CF633_Set_ATX_Power_Switch_Functionality", "CF633_Enable_Disable_and_Reset_the_Watchdog",
	"CF633_Read_Reporting_and_Status", "CF633_Send_Data_to_LCD", "CF633_Key_Legends",
	"?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", 
	"?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?", "?" };

/*
 * 633 Sensors Data 
 */
unsigned char tempcount=0;
int syslogsensors=0;
CF_633_DS18 *CF633temps=NULL; // create pointer here and malloc in CFontz633.c init 
CF_633_FAN *CF633fans=NULL; 
long int other_packets[64];
unsigned char init_completed = 0; // flag to skip most of sensors_packet until init is done
struct lcd_logical_driver* drvthis633=NULL;
Screen *CF633Screens[20];
int CF633ScreenCount=0;
int CF633WidgetCount=0;

/*-OK-----------------------------------------------------------------------*/
void EmptyKeyRing(void)
  {
  KeyHead=KeyTail=0;
  }

/*-OK-----------------------------------------------------------------------*/
int AddKeyToKeyRing(unsigned char key) {
  int oldhead;

/*  printf("We add key: %d\n", key); */

  oldhead=KeyHead;
  KeyHead++;
  if (KeyHead==KEYRINGSIZE) KeyHead=0;
  if (KeyHead!=KeyTail) {
          KeyRing[oldhead]=key;
	  return 1;
  	  }
  /* We have a KeyRing overflow */
  /* We do not accept extra key */
  KeyHead=oldhead; 
  return 0;
  }

/*-OK-----------------------------------------------------------------------*/
unsigned char GetKeyFromKeyRing(void) {
  int retval=0;

  if (KeyHead!=KeyTail) {
	retval=KeyRing[KeyTail];
        KeyTail++;
        if (KeyTail==KEYRINGSIZE) KeyTail=0;
  	}

/*  if (retval) printf("We remove key: %d\n", retval); */

  return retval;
  }



/*
 * ---------------------------------------------------------------------------- 
 * send_packet() send_packet() will send set the CRC in outgoing_response 
 * and send it to the host.
 * ---------------------------------------------------------------------------- 
 */
void send_bytes_message(int fd, int len, int msg, char *framebuf)
{
    int i;
    outgoing_response.command=msg;
    outgoing_response.data_length=len;
    for (i = 0; i < outgoing_response.data_length; i++) {
        outgoing_response.data[i]=framebuf[i];
    }
    send_packet(fd);
}

void send_onebyte_message(int fd, int msg, int value)
{
    outgoing_response.command=msg;
    outgoing_response.data_length=1;
    outgoing_response.data[0]=value;
	drvthis633->report(RPT_DEBUG, "CFontz633io.c send_onebyte_message( %d, %d, %d)",
			outgoing_response.command, outgoing_response.data_length,
			outgoing_response.data[0]);
    send_packet(fd);
}

void send_zerobyte_message(int fd, int msg)
{
    outgoing_response.command=msg;
    outgoing_response.data_length=0;
    send_packet(fd);
}


/*----------------------------------------------------------------------------*/
int get_crc(char *bufptr, int len, int seed)
{

    /*
     * CRC lookup table to avoid bit-shifting loops. 
     */
    static const word crcLookupTable[256] = {
	0x00000, 0x01189, 0x02312, 0x0329B, 0x04624, 0x057AD, 0x06536, 0x074BF,
	0x08C48, 0x09DC1, 0x0AF5A, 0x0BED3, 0x0CA6C, 0x0DBE5, 0x0E97E, 0x0F8F7,
	0x01081, 0x00108, 0x03393, 0x0221A, 0x056A5, 0x0472C, 0x075B7, 0x0643E,
	0x09CC9, 0x08D40, 0x0BFDB, 0x0AE52, 0x0DAED, 0x0CB64, 0x0F9FF, 0x0E876,
	0x02102, 0x0308B, 0x00210, 0x01399, 0x06726, 0x076AF, 0x04434, 0x055BD,
	0x0AD4A, 0x0BCC3, 0x08E58, 0x09FD1, 0x0EB6E, 0x0FAE7, 0x0C87C, 0x0D9F5,
	0x03183, 0x0200A, 0x01291, 0x00318, 0x077A7, 0x0662E, 0x054B5, 0x0453C,
	0x0BDCB, 0x0AC42, 0x09ED9, 0x08F50, 0x0FBEF, 0x0EA66, 0x0D8FD, 0x0C974,
	0x04204, 0x0538D, 0x06116, 0x0709F, 0x00420, 0x015A9, 0x02732, 0x036BB,
	0x0CE4C, 0x0DFC5, 0x0ED5E, 0x0FCD7, 0x08868, 0x099E1, 0x0AB7A, 0x0BAF3,
	0x05285, 0x0430C, 0x07197, 0x0601E, 0x014A1, 0x00528, 0x037B3, 0x0263A,
	0x0DECD, 0x0CF44, 0x0FDDF, 0x0EC56, 0x098E9, 0x08960, 0x0BBFB, 0x0AA72,
	0x06306, 0x0728F, 0x04014, 0x0519D, 0x02522, 0x034AB, 0x00630, 0x017B9,
	0x0EF4E, 0x0FEC7, 0x0CC5C, 0x0DDD5, 0x0A96A, 0x0B8E3, 0x08A78, 0x09BF1,
	0x07387, 0x0620E, 0x05095, 0x0411C, 0x035A3, 0x0242A, 0x016B1, 0x00738,
	0x0FFCF, 0x0EE46, 0x0DCDD, 0x0CD54, 0x0B9EB, 0x0A862, 0x09AF9, 0x08B70,
	0x08408, 0x09581, 0x0A71A, 0x0B693, 0x0C22C, 0x0D3A5, 0x0E13E, 0x0F0B7,
	0x00840, 0x019C9, 0x02B52, 0x03ADB, 0x04E64, 0x05FED, 0x06D76, 0x07CFF,
	0x09489, 0x08500, 0x0B79B, 0x0A612, 0x0D2AD, 0x0C324, 0x0F1BF, 0x0E036,
	0x018C1, 0x00948, 0x03BD3, 0x02A5A, 0x05EE5, 0x04F6C, 0x07DF7, 0x06C7E,
	0x0A50A, 0x0B483, 0x08618, 0x09791, 0x0E32E, 0x0F2A7, 0x0C03C, 0x0D1B5,
	0x02942, 0x038CB, 0x00A50, 0x01BD9, 0x06F66, 0x07EEF, 0x04C74, 0x05DFD,
	0x0B58B, 0x0A402, 0x09699, 0x08710, 0x0F3AF, 0x0E226, 0x0D0BD, 0x0C134,
	0x039C3, 0x0284A, 0x01AD1, 0x00B58, 0x07FE7, 0x06E6E, 0x05CF5, 0x04D7C,
	0x0C60C, 0x0D785, 0x0E51E, 0x0F497, 0x08028, 0x091A1, 0x0A33A, 0x0B2B3,
	0x04A44, 0x05BCD, 0x06956, 0x078DF, 0x00C60, 0x01DE9, 0x02F72, 0x03EFB,
	0x0D68D, 0x0C704, 0x0F59F, 0x0E416, 0x090A9, 0x08120, 0x0B3BB, 0x0A232,
	0x05AC5, 0x04B4C, 0x079D7, 0x0685E, 0x01CE1, 0x00D68, 0x03FF3, 0x02E7A,
	0x0E70E, 0x0F687, 0x0C41C, 0x0D595, 0x0A12A, 0x0B0A3, 0x08238, 0x093B1,
	0x06B46, 0x07ACF, 0x04854, 0x059DD, 0x02D62, 0x03CEB, 0x00E70, 0x01FF9,
	0x0F78F, 0x0E606, 0x0D49D, 0x0C514, 0x0B1AB, 0x0A022, 0x092B9, 0x08330,
	0x07BC7, 0x06A4E, 0x058D5, 0x0495C, 0x03DE3, 0x02C6A, 0x01EF1, 0x00F78
    };

    /*
     * Initial value of the CRC. 
     */
    int             newCrc;

    /*
     * seed should be 0xFFFF; 
     */
    newCrc = seed;

    /*
     * This algorithim is based on the IrDA LAP example. 
     */
    while (len--)
	newCrc =
	    (newCrc >> 8) ^ crcLookupTable[(newCrc ^ *bufptr++) & 0xff];

    /*
     * Make this crc match the one's complement that is sent in the packet. 
     */
    return (~newCrc);
}


void
SendByte(int fd, unsigned char datum)
{
    int bytes_written;
    bytes_written = 0;
    bytes_written = write(fd, &datum, 1);
/*    if (bytes_written != 1) {
	printf("SendByte(): only %d of %d bytes sent.", bytes_written, 1);
    } */

    return;
}

/*---------------------------------------------------------------------------*/

COMMAND_PACKET  outgoing_response;

/*
 * ============================================================================ 
 * send_packet() send_packet() will send set the CRC in outgoing_response 
 * and send it to the host.
 * ---------------------------------------------------------------------------- 
 */

void
send_packet(int fd)
{
    unsigned char           i;

    SendByte(fd, outgoing_response.command);
    SendByte(fd, outgoing_response.data_length);
    for (i = 0; i < outgoing_response.data_length; i++) {
	SendByte(fd, outgoing_response.data[i]);
    }
    /*
     * Set the CRC 
     */
    outgoing_response.CRC.as_word =
	get_crc((unsigned char *) & outgoing_response,
		outgoing_response.data_length + 2, 0xFFFF);
    SendByte(fd, outgoing_response.CRC.as_bytes[0]);
    SendByte(fd, outgoing_response.CRC.as_bytes[1]);

/**** TEST STUF ****/
//    print_packet(&outgoing_response);

    /* Every time we send a message, we also check for incomming one. */
    test_packet(fd); 
}



/*============================================================================
 * 635 WinTest Code.
 * Copyright 2001, Crystalfontz America, Inc. Written by Brent A. Crosby
 * www.crystalfontz.com, brent@crystalfontz.com
 *============================================================================
 */

/*---------------------------------------------------------------------------*/
/* This is some code that kind of makes the windows stuff look a little
 * like the DOS/633 interrupt driven serial stuff. Basically there is a
 * circular buffer, and Sync_Read_Buffer() uses ReadFile() to put data
 * into the circular buffer much like the DOS stuff uses an ISR to put
 * the data into the buffer. Then the rest of the functions work like
 * the counterparts in the 633,
 */



/*                  v TailPeek                        */
/* -------------------------------------------------- */
/*           ^ Tail              ^ Head               */

/*-OK-----------------------------------------------------------------------*/
void EmptyReceiveBuffer(void)
  {
  ReceiveBufferHead=ReceiveBufferTail=0;
  }

/*-OK------------------------------------------------------------------------
 * Gets incoming data from Window's ReadFile() and puts it into
 * SerialReceiveBuffer[].
 */
void Sync_Read_Buffer(int fd, unsigned char expected_bytes)
  {
	unsigned char	Incoming[512];
	int		BytesRead;
	int		i;

	BytesRead = read(fd, Incoming, expected_bytes);
	if (BytesRead==-1){
/*		printf("~~~Problem reading: %s .\n", strerror(errno)); */
	}
	else
	    {
/*            printf("Readed %d Bytes:", BytesRead); */

	/* Read the incoming unsigned char, store it, */
	    for(i=0; i<BytesRead; i++)
		{
/*  		printf(" %02x", Incoming[i]); */
		SerialReceiveBuffer[ReceiveBufferHead]=Incoming[i];
		/* Increment the pointer and wrap if needed. */
		ReceiveBufferHead++;
		if(RECEIVEBUFFERSIZE<=ReceiveBufferHead)
			ReceiveBufferHead=0;
		}
/*                printf("\n"); */
	    }
  }



/*-OK-----------------------------------------------------------------------*/
int BytesAvail(void)
  {
  int    return_value;

  return_value=ReceiveBufferHead-ReceiveBufferTail;
  if(return_value<0)
    return_value+=RECEIVEBUFFERSIZE;
  return(return_value);
  }

/*-OK-----------------------------------------------------------------------*/
unsigned char GetByte(void)
  {
  unsigned char    return_byte;
  
  return_byte=0;

  /* See if there are any more bytes available. */
  if(ReceiveBufferTail!=ReceiveBufferHead)
    {
    /* There is at least one more ubyte. */
    return_byte=SerialReceiveBuffer[ReceiveBufferTail];

    /* Increment the pointer and wrap if needed. */
    ReceiveBufferTail++;
    if(RECEIVEBUFFERSIZE<=ReceiveBufferTail)
      ReceiveBufferTail=0;
    }

  return(return_byte);
  }

/*-OK-----------------------------------------------------------------------*/
unsigned char DiscardGetByte(void)
  {
  unsigned char    return_byte;
  
  return_byte=0;

  /* See if there are any more bytes available. */
  if(ReceiveBufferTail!=ReceiveBufferHead)
    {
    /* There is at least one more ubyte. */
    return_byte=SerialReceiveBuffer[ReceiveBufferTail];

    /* Increment the pointer and wrap if needed. */
    ReceiveBufferTail++;
    if(RECEIVEBUFFERSIZE<=ReceiveBufferTail)
      ReceiveBufferTail=0;
    }
  
/*  printf("Discarded : /%02x/\n", return_byte); */

  return(return_byte);
  }


/*-OK--------------------------------------------------------------------------*/
int PeekBytesAvail(void)
  {
  int    return_value;
    
  return_value=ReceiveBufferHead-ReceiveBufferTailPeek;

  if(return_value<0)
    return_value+=RECEIVEBUFFERSIZE;

  return(return_value);
  }

/*-OK--------------------------------------------------------------------------*/
void Sync_Peek_Pointer(void)
  {
  ReceiveBufferTailPeek=ReceiveBufferTail;
  }

/*-OK--------------------------------------------------------------------------*/
void AcceptPeekedData(void)
  {
  ReceiveBufferTail=ReceiveBufferTailPeek;
  }

/*-OK--------------------------------------------------------------------------*/
unsigned char PeekByte(void)
  {
  unsigned char return_byte;

  return_byte=0;

  /* See if there are any more bytes available. */
  if(ReceiveBufferTailPeek!=ReceiveBufferHead)
    {
    /* There is at least one more byte. */
    return_byte=SerialReceiveBuffer[ReceiveBufferTailPeek];

    /* Increment the pointer and wrap if needed. */
    ReceiveBufferTailPeek++;
    if(RECEIVEBUFFERSIZE<=ReceiveBufferTailPeek)
      ReceiveBufferTailPeek=0;
    }

  return(return_byte);
  }


void treat_packet(void){
	AddKeyToKeyRing(incoming_command.data[0]);
}

void sensors_packet(int fd)
	/*
	 * 	notes on bloating treat _ packet 
	 * 	calling check _ for _ packet from within treat _ packet creates infinitely deepening recursion, necessarily.... 
	 *	what called treat_packet? could check for command types previously?
	 */
{
	if ( init_completed == 1) { // create some screens
		init_completed=2;
		CF633ScreenCount=0;
		CF633WidgetCount=0;
		char name[8];
		int tempy,screen;
		int didtempwidget[32]={0,0,0,0,0,0,0,0,
					0,0,0,0,0,0,0,0,
					0,0,0,0,0,0,0,0};
		screen=0;
		for (tempy=0; tempy <   4; tempy ++){ // for each fan linked to temp 
			 if ( (CF633fans[tempy].dowidget==1) && (CF633fans[tempy].sensor !=0 ) ){ 
				sprintf (name, "_633%02df+t",  CF633ScreenCount);
				drvthis633->report (4, "LCDd: cfontz633io.c: Screen Create, fan temp pair, screen %d, fan %d                     %s.",
					 CF633ScreenCount, tempy, name );
				CF633Screens[CF633ScreenCount]=screen_create(name,NULL);
				CF633Screens[CF633ScreenCount]->heartbeat = HEARTBEAT_OFF;
				if (CF633temps[CF633fans[tempy].sensor-1].dowidget==0){
					CF633temps[CF633fans[tempy].sensor-1].dowidget=1;
				}
				didtempwidget[CF633fans[tempy].sensor-1]=1+CF633ScreenCount;
					// didtempwidget = screen to add this widget to +1
				// create line 1 widget
				sprintf (name, "_633%02dpf",  CF633WidgetCount);
				drvthis633->report (4, "LCDd: cfontz633io.c: Widget Create, screen %d, fan %d top, widget %d %s.",
						CF633ScreenCount,  tempy, CF633WidgetCount, CF633fans[tempy].name);
				CF633fans[tempy].aswidget[0]=widget_create(name,  WID_STRING,  CF633Screens[CF633ScreenCount]);
			 	CF633fans[tempy].aswidget[0]->y=1;
			 	CF633fans[tempy].aswidget[0]->x=1;
			 	CF633fans[tempy].aswidget[0]->height=1;
			 	CF633fans[tempy].aswidget[0]->text= malloc(17);
				CF633fans[tempy].aswidget[0]->width= CF633Screens[CF633ScreenCount]->width;
				CF633fans[tempy].aswidget[0]->length= CF633Screens[CF633ScreenCount]->width;
				sprintf(CF633fans[tempy].aswidget[0]->text, "%s                ", CF633fans[tempy].name);
				sprintf(CF633fans[tempy].aswidget[0]->text+7, " ");
				screen_add_widget (CF633Screens[screen], CF633fans[tempy].aswidget[0]);
				CF633WidgetCount++;
				// create line 2 widget
				sprintf (name, "_633%02dpt",  CF633WidgetCount);
				drvthis633->report (4, "LCDd: cfontz633io.c: Widget Create, screen %d, fan %d, sense %d, bot, widget %d %s.",
						CF633ScreenCount,  tempy, CF633fans[tempy].sensor, CF633WidgetCount,CF633temps[CF633fans[tempy].sensor-1].name );
				CF633fans[tempy].aswidget[1]=
					widget_create(name,  WID_STRING,  CF633Screens[CF633ScreenCount]);
			 	CF633fans[tempy].aswidget[1]->text= malloc(17);
				if (CF633fans[tempy].sen_ref==0) { // if it is a simple temp
					snprintf(CF633fans[tempy].aswidget[1]->text, 9, "%s        ", CF633temps[CF633fans[tempy].sensor-1].name);
					snprintf(CF633fans[tempy].aswidget[1]->text+7, 9, "        ");
				//	sprintf(CF633fans[tempy].aswidget[1]->text, "%s                ",
				//		CF633temps[CF633fans[tempy].sensor-1].name);
				}
				else { // it is a relative temp
					snprintf(CF633fans[tempy].aswidget[1]->text, 9, "%s        ",
						CF633temps[CF633fans[tempy].sensor-1].name);
					snprintf(CF633fans[tempy].aswidget[1]->text+4, 5, "%s    ",
						CF633temps[CF633fans[tempy].sen_ref-1].name);
				}
				sprintf(CF633fans[tempy].aswidget[1]->text+7, " ");
				CF633fans[tempy].aswidget[1]->y=2;
			 	CF633fans[tempy].aswidget[1]->x=1;
			 	CF633fans[tempy].aswidget[1]->height=1;
				CF633fans[tempy].aswidget[1]->width= CF633Screens[CF633ScreenCount]->width;
				CF633fans[tempy].aswidget[1]->length= CF633Screens[CF633ScreenCount]->width;
				screen_add_widget (CF633Screens[CF633ScreenCount], CF633fans[tempy].aswidget[1]);
				CF633WidgetCount++;
				CF633ScreenCount++;
			 } // end for is a temp conrolled fan
		} // end for each fan

		for (tempy=0; tempy <   4; tempy ++){ 
			 if ( (CF633fans[tempy].dowidget ==1 ) && (CF633fans[tempy].sensor ==0 ) ) {
				if ((1&CF633WidgetCount)==0){ // first widget in screen
					sprintf (name, "_633%02df+?",  CF633ScreenCount);
					drvthis633->report (4, "LCDd: cfontz633io.c: Screen Create, single fan line, screen %d, fan %d                %s.",
						 CF633ScreenCount, tempy, name );
					CF633Screens[CF633ScreenCount]=screen_create(name,NULL);
					CF633Screens[CF633ScreenCount]->heartbeat = HEARTBEAT_OFF;
				}
				sprintf (name, "_633%02dsf",  CF633WidgetCount);
				drvthis633->report (4, "LCDd: cfontz633io.c: Widget Create, sigle fan, screen %d, fan %d, widget %d %s.",
						CF633ScreenCount,  tempy,  CF633WidgetCount, CF633fans[tempy].name );
				CF633fans[tempy].aswidget[0]=widget_create(name,  WID_STRING,  CF633Screens[CF633ScreenCount]);
			 	CF633fans[tempy].aswidget[0]->text= malloc(17);
				snprintf(CF633fans[tempy].aswidget[0]->text, 9, "%s        ", CF633fans[tempy].name);
				snprintf(CF633fans[tempy].aswidget[0]->text+7, 9, "        ");
			 	CF633fans[tempy].aswidget[0]->height=1;
			 	CF633fans[tempy].aswidget[0]->x=1;
				CF633fans[tempy].aswidget[0]->width= CF633Screens[CF633ScreenCount]->width;
				CF633fans[tempy].aswidget[0]->length= CF633Screens[CF633ScreenCount]->width;
				if ((1&CF633WidgetCount)==0){ // first widget in screen
			 		CF633fans[tempy].aswidget[0]->y=1;
				}
				else { // second widget in screen
			 		CF633fans[tempy].aswidget[0]->y=2;
					CF633ScreenCount++;
				}
				screen_add_widget (CF633Screens[CF633ScreenCount], CF633fans[tempy].aswidget[0]);
				CF633WidgetCount++;
			 } // end for is a non -temp controlled fan
		}  //end for each fan

		for (tempy=0; tempy <   tempcount; tempy ++){ // for temps not attatched to a previous fan screen 
			 if ((CF633temps[tempy].dowidget==1)&& (didtempwidget[tempy]==0))  {
				if ((1&CF633WidgetCount)==0){ // first widget in screen
					sprintf (name, "_633%02dt+?",  CF633ScreenCount);
					drvthis633->report (4, "LCDd: cfontz633io.c: Screen Create, single sensor line, screen %d, sensor %d                %s.",
						 CF633ScreenCount, tempy, name );
					CF633Screens[CF633ScreenCount]=screen_create(name,NULL);
					CF633Screens[CF633ScreenCount]->heartbeat = HEARTBEAT_OFF;
					}
				sprintf (name, "_633%02dt",  CF633WidgetCount);
				drvthis633->report (4, "LCDd: cfontz633io.c: Widget Create, sigle sensor, screen %d, sensor %d, widget %d %s.",
						CF633ScreenCount,  tempy, CF633WidgetCount,  CF633temps[tempy].name );
				CF633temps[tempy].aswidget=widget_create(name,  WID_STRING,  CF633Screens[CF633ScreenCount]);
			 	CF633temps[tempy].aswidget->text= malloc( 17);
				snprintf(CF633temps[tempy].aswidget->text, 9, "%s        ", CF633temps[tempy].name);
				snprintf(CF633temps[tempy].aswidget->text+7, 9, "        ");
			 	CF633temps[tempy].aswidget->x=1;
			 	CF633temps[tempy].aswidget->height=1;
				CF633temps[tempy].aswidget->width= CF633Screens[CF633ScreenCount]->width;
				CF633temps[tempy].aswidget->length= CF633Screens[CF633ScreenCount]->width;
				if ((1&CF633WidgetCount)==0){ // first widget in screen
			 		CF633temps[tempy].aswidget->y=1;
				}
				else { // second widget in screen
			 		CF633temps[tempy].aswidget->y=2;
				}
				screen_add_widget (CF633Screens[CF633ScreenCount], CF633temps[tempy].aswidget);
				 if ((1&CF633WidgetCount)==1) { // second widget in screen
					CF633ScreenCount++;
				}
				CF633WidgetCount++;
			 } // end for was an unattached temp
		} // end for each temp
		if ((1&CF633WidgetCount)==1) { // odd number of widgets
			// this screen gets extra line 
			snprintf (name, 9, "oddwidget");
			Widget* oddwidget = widget_create(name,  WID_STRING,  CF633Screens[CF633ScreenCount]);
			oddwidget->text= malloc( 17);
			snprintf(oddwidget->text, 17, "%02d temps %02d scns", tempcount, CF633ScreenCount+1);
			oddwidget->x=1 ;
			oddwidget->height=1 ;
			oddwidget->width=CF633Screens[CF633ScreenCount]->width ;
			oddwidget->length=CF633Screens[CF633ScreenCount]->width ;
			oddwidget->y=2 ;
			screen_add_widget (CF633Screens[CF633ScreenCount], oddwidget);
			drvthis633->report (4, "LCDd: cfontz633io.c: Widget Create, trailing oddwidget / info, screen %d,  widget %d.",
						CF633ScreenCount,   CF633WidgetCount );
			CF633ScreenCount++;
			CF633WidgetCount++;
		}
			
		drvthis633->report (4, "CFontz633io.c init %d widgets in %d screens.", CF633WidgetCount,
				 CF633ScreenCount);
		
		for (screen=0; screen < CF633ScreenCount; screen ++){ // tidy common values and add screens
			CF633Screens[screen]->priority= PRI_INFO;
			CF633Screens[screen]->duration=200;
			screenlist_add (CF633Screens[screen]);
		}
	}  // end of init  screens & widgets
	else if (incoming_command.command==0x52) {  // a CF633_Read_DOW_Device_Information packet during init
		/* it is always sensor zero, and happens less frequenty when the
		 * usleep() in ds18_init is high, above 70000
		 * at the moment I'm not sure why it winds up here sometimes
		 * throw it back and sensors get detected on 1st try, (always?)
		 */
		drvthis633->report (4, "CFontz633io.c sensors_packet recieved a CF633_Read_DOW_Device_Information for sensor %d.",
				incoming_command.data[0]+1 );
		send_onebyte_message(fd, CF633_Read_DOW_Device_Information, incoming_command.data[0]);
//		print_packet(&incoming_command);
		return;
	}
	else if (init_completed == 0) return;  // if before CF633fans and CF633temps mallocs in init
	else if (incoming_command.command==0x82) {
		if (CF633temps==NULL){
			drvthis633->report (RPT_DEBUG, "CFontz633io.c sensors_packet recieved a report on sensor %d, while (CF633temps==NULL).",
				incoming_command.data[0]+1 );
			return;  
		}
		if (incoming_command.data[0]==tempcount){
			drvthis633->report (RPT_DEBUG, "CFontz633io.c sensers_packet recieved a packet for sensor %d, beyond expected %d.",
				incoming_command.data[0]+1, tempcount );
			return;  
		}
		unsigned char  msb=incoming_command.data[2] % 8; // only 3 least significant bits are temp values
		char sign = (incoming_command.data[2] > 7) ? -1 : 1; // > 7 means subzero   
		if (sign == -1) msb = 7 - msb; // read www.maxim-ic.com's ds18b20.pdf page 3 for bit usage 
		if (incoming_command.data[3] == 0) 
			CF633temps[incoming_command.data[0]].ds18=DEFAULT_DS18_TEMP; // denotes bad CRC 
		else  
			CF633temps[incoming_command.data[0]].ds18=sign*(incoming_command.data[1]+256*msb);
			// (ds1820 / ds18b20 "abstracto-increments") / 16 == degrees celcius 
		if (CF633temps[incoming_command.data[0]].aswidget!=NULL) { // if this temp has a default widget
			sprintf(CF633temps[incoming_command.data[0]].aswidget->text+8, "%f",
					(float)CF633temps[incoming_command.data[0]].ds18/16 );
		}
		if (incoming_command.data[0]<tempcount-1) return; // if not last temp report this second, skip the rest
	} // end command==0x82 temp update case  CRC - compute - store Temperatures, begin Fans
	else if (incoming_command.command==0x81)   { // fan autoreport packet 
		if (CF633fans==NULL){
			drvthis633->report (RPT_DEBUG, "CFontz633io.c sensors_packet recieved a fan report while (CF633fans==NULL)." );
			return;  
		}
		if (incoming_command.data[1]<3) { // device too slow to report properly, 0=complete stop
			CF633fans[incoming_command.data[0]].rpm_rpt=incoming_command.data[1];
		}
		else {	// "27692308" is a constant 
			CF633fans[incoming_command.data[0]].rpm_rpt=( ((float)incoming_command.data[1]-3)*27692308) 
						/ ((float)(*(unsigned short *)(&incoming_command.data[2]) )
						   *(float)CF633fans[incoming_command.data[0]].divisor) ;
		}
		if (CF633fans[incoming_command.data[0]].aswidget[0]!=NULL) { // if this fan has a default widget
			sprintf(CF633fans[incoming_command.data[0]].aswidget[0]->text+8, "%f", 
				CF633fans[incoming_command.data[0]].rpm_rpt );
		} 	
		if (CF633fans[incoming_command.data[0]].aswidget[1]!=NULL) { // if this fan has an asociated temp widget
			if (CF633fans[incoming_command.data[0]].sen_ref==0) { // if simple temp 
				sprintf(CF633fans[incoming_command.data[0]].aswidget[1]->text+8, "%f", 
					(float)CF633temps[CF633fans[incoming_command.data[0]].sensor-1].ds18/16 );
			}
			else { // relative temp
				sprintf(CF633fans[incoming_command.data[0]].aswidget[1]->text+8, "%f", 
					(float)(CF633temps[CF633fans[incoming_command.data[0]].sensor-1].ds18
						-CF633temps[CF633fans[incoming_command.data[0]].sen_ref-1].ds18)
					/16 );
			}
		} 	
	} // end of incoming_command.command==0x81  store  reported fan speeds  
	else  { 	// is not a key, temp, or fan  ....
		if (incoming_command.data_length >0) {  // is it not empty?
			other_packets[0x3F&incoming_command.command]++;
			// tally what else is arriving here for curiosity ...
			print_packet(&incoming_command);
		}	
		return;  // and nothing else to do... 
	}
	

	static long int did_syslog=0;
	static long int did_power=0;
	long int is_now=0;
	static long int did_fan[4]={0,0,0,0};
	struct timeval current_time;
	static unsigned char p_mask_o[4]={3,3,3,3}; // storage to test if power  settings are new
	static unsigned char r_mask_o[4]={2,2,2,2}; // storage to test if report settings are new
	static char r_mask[4]={0,0,0,0};   
//	char out[4]={0,0,0,0};   
	static unsigned char p_mask[4]={0,0,0,0};
	int fan=0;
	
	gettimeofday(&current_time,NULL);
	is_now=current_time.tv_sec;
	for (fan=0; fan < 4; fan ++){  // for each fan  
		if   ((is_now  - did_fan[fan]) >= CF633fans[fan].a_sec) {
			if  (CF633fans[fan].sensor!=0) {
				// every fan_cycle seconds calculate and adjust fan power
				double temperat = (CF633fans[fan].sen_ref==0) ? CF633temps[CF633fans[fan].sensor-1].ds18: 
					CF633temps[CF633fans[fan].sensor-1].ds18 - CF633temps[CF633fans[fan].sen_ref-1].ds18;
				CF633fans[fan].power=(int)(FAN_LOW_POWER_PERCENT+
						(((float)temperat*CF633fans[fan].t_conv -(float)CF633fans[fan].by_s_off) / 
						 ((float)CF633fans[fan].by_s_100 -(float)CF633fans[fan].by_s_off)
					*(100-FAN_LOW_POWER_PERCENT)));
				drvthis633->report(RPT_DEBUG, "CF633io.c: temp calcs fan %d, sensor %d(%3.4f), ref %d(%3.4f), temperat %3.4f, power %3d(%3d).",
						fan+1, CF633fans[fan].sensor, (float)CF633temps[CF633fans[fan].sensor-1].ds18/16,
						CF633fans[fan].sen_ref, (float)CF633temps[CF633fans[fan].sen_ref-1].ds18/16,
								(float)temperat/16
						, CF633fans[fan].power, (int)((CF633fans[fan].power -FAN_LOW_POWER_PERCENT)*2.5));
				if ( CF633fans[fan].power > 100) CF633fans[fan].power=100; 
				if (CF633fans[fan].power < FAN_LOW_POWER_PERCENT) {
					CF633fans[fan].power=0; 
					r_mask[fan]=0; 
					CF633fans[fan].rpm_rpt=0; // a stopped, non-reporting  fan will not autoreport 0 rpm  
					if (CF633fans[fan].aswidget!=NULL) { // if this fan has a default widget
						sprintf(CF633fans[fan].aswidget[0]->text+8, "%f", 
							CF633fans[fan].rpm_rpt );
					} 	
				}
				else {   // set these once at top for non-temp fans...?
					r_mask[fan]=CF633fans[fan].autoreport; 
				}
			} // end is a temperature controlled fan
			else { // set masks by config for non adjusting fans
				r_mask[fan]=CF633fans[fan].autoreport; 
			}
			did_fan[fan]=current_time.tv_sec;
			p_mask[fan]=CF633fans[fan].power; 
			drvthis633->report (RPT_DEBUG, "CF633io.c: fan %d t %d, new p %d, new r %d.", fan +1, 
					((CF633fans[fan].sensor!=0)? 0: CF633fans[fan].sensor), CF633fans[fan].power, r_mask[fan]);
		} // end it is time to adjust fan # fan
	} // end adjust for all fans 
/*
 * set r_mask first ?
 * keeps fan at 0 from limping on sensing boost juice only..
 */
	if ((r_mask[0]!=r_mask_o[0])||(r_mask[1]!=r_mask_o[1])||(r_mask[2]!=r_mask_o[2])
			||(r_mask[3]!=r_mask_o[3])) { // only if report settings have changed 
		send_onebyte_message(fd, CF633_Set_Up_Fan_Reporting, 0);
		usleep(10000);
//		out[0]= r_mask[0]+2*r_mask[1]+4*r_mask[2]+8*r_mask[3];
//		send_onebyte_message(fd, CF633_Set_Up_Fan_Reporting, out[0]); 
		send_onebyte_message(fd, CF633_Set_Up_Fan_Reporting,  
			(r_mask[0]+2*r_mask[1]+4*r_mask[2]+8*r_mask[3]));
		drvthis633->report (RPT_DEBUG, "r_mask update  %d %d %d %d   -> %d %d %d %d.", 
				r_mask_o[0], r_mask_o[1], r_mask_o[2], r_mask_o[3], r_mask[0], r_mask[1], r_mask[2], r_mask[3]);
		for (fan=0; fan < 4; fan ++)  r_mask_o[fan]=r_mask[fan];
	}  // end packeting for new report settings
	if ((p_mask[0]!=p_mask_o[0])||(p_mask[1]!=p_mask_o[1])||(p_mask[2]!=p_mask_o[2])||(p_mask[3]!=p_mask_o[3])
			|| (current_time.tv_sec-did_power > 30) ) { // if any power settings have changed
		                                         	     // or the failsafe might kick in	
//		for (fan=0; fan < 4; fan ++)  out[fan]=0;	    	
//		send_bytes_message(fd, 4, CF633_Set_Fan_Power , out);
//		usleep(10000);
/*
 * were succesive p _ mask updates without resetting to zero confusing
 * something, or  ?  
 * seems to take seconds to process and set a new power level sometimes,
 * so get rid of reset to zero if viable...  less fan wandering.
 */
		send_bytes_message(fd, 4, CF633_Set_Fan_Power , p_mask);
		drvthis633->report (RPT_DEBUG, "p_mask update  %3d %3d %3d %3d -> %3d %3d %3d %3d     %ld.", 
				p_mask_o[0], p_mask_o[1], p_mask_o[2], p_mask_o[3], p_mask[0], p_mask[1], p_mask[2], p_mask[3],
				is_now-1095194199); // ...roughly seconds since I wrote this... 
		for (fan=0; fan < 4; fan++)  p_mask_o[fan]=p_mask[fan];
		did_power=current_time.tv_sec;
	} // end packeting for new power level

	if ((is_now  - did_syslog )>= syslogsensors) { // every sylogsensors'th second 
		//char p[10+8*tempcount]; // 2+ is adeqate temps only 
		char p[1024];
		int counter;
		char buf[255];
		int lineused=0;
		sprintf (buf, ",CF633data");
		sprintf (p+lineused, buf);
		lineused += strlen(buf);
		for (counter=0; counter  < 4; counter ++){  // for each fan  
			if (CF633fans[counter].p_log!=0) { // if this fan logs power setting
				sprintf (buf, ",%03d", CF633fans[counter].power );
				sprintf (p+lineused, buf);
				lineused += strlen(buf);
			}
			if (CF633fans[counter].autoreport!=0) { // if this logs sensing
				if (CF633fans[counter].divisor < 20) { // fans 
					sprintf (buf, ",%04d", (int)CF633fans[counter].rpm_rpt );
				}
				else {  // other divisors & display units
					sprintf (buf, ",%f", CF633fans[counter].rpm_rpt );
				}
				sprintf (p+lineused, buf);
				lineused += strlen(buf);
			}
		} // done with fan  info
		for (counter=0; counter < tempcount; counter ++){  // add temp info  
			sprintf (buf, ",%2.4f", (float)CF633temps[counter].ds18 /16 );
			sprintf (p+lineused, buf);
			lineused += strlen(buf);
		} // done with temp info
		if (drvthis633==NULL){
			drvthis633->report (RPT_CRIT, "treat packet drvthis==NULL\n" );
		}
		else if (syslogsensors) { 
			drvthis633->report (RPT_CRIT, "%s", p );
		}
		did_syslog=current_time.tv_sec;
	} //end of if time to display
} // end of treat packet


/*============================================================================
 *                              check_for_packet()
 *
 * check_for_packet() will see if there is a valid packet in the input buffer.
 * If there is, it will copy it into incoming_command and return 1. If there
 * is not it will return 0. incoming_packet may get partially filled with
 * garbage if there is not a valid packet available.
 *----------------------------------------------------------------------------
 */

/* This tossed byte is not in use, it's going to be removed. */
int tossed=0;

/* Let's return
 * O if we have no message but we should try again immediatly
 * 1 if we have a message correctly identified
 * 2 if we have no message and we should not retry until new input
 * So a loop should run as long as we have no 0
 * If we have a 2 we should avoid comming back there.
 */

#define TRY_AGAIN 0
#define GOOD_MSG 1
#define GIVE_UP 2

unsigned char check_for_packet(int fd, unsigned char expected_length)
  {
  int i;
  int testcrc;

  Sync_Read_Buffer(fd, expected_length);

  //First off, there must be at least 4 bytes available in the input stream
  //for there to be a valid command in it (command, length, no data, CRC).
  if(BytesAvail()<4) {
/*    printf("Not enough byte available for even the smallest message.\n"); */
    return(GIVE_UP); /* We don't need to retry before more byte are received */
  }

  /* Look into the buffer without removing the data. */
  Sync_Peek_Pointer();

  //Only commands 0 through MAX_COMMAND are valid.
  if(MAX_COMMAND<(0x3F&(incoming_command.command=PeekByte())))
    {
    /* Throw out one byte of garbage. Next pass through should re-sync. */
    DiscardGetByte();
    tossed++;
/*    printf("###: Unknown command.\n"); */
    return(TRY_AGAIN);
    }
  /* There is a valid command byte. Get the data_length. */
  /* The data length must be within reason. */
  if(MAX_DATA_LENGTH<(incoming_command.data_length=PeekByte()))
    {
    //Throw out one byte of garbage. Next pass through should re-sync.
    DiscardGetByte();
    tossed++;
/*    printf("###: Too long packet: %d.\n", incoming_command.data_length); */
    return(TRY_AGAIN);
    }

  //Now there must be at least incoming_command.data_length+sizeof(CRC) bytes
  //still available for us to continue.
  if((int)PeekBytesAvail()<(incoming_command.data_length+2)) {
    //It looked like a valid start of a packet, but it does not look
    //like the complete packet has been received yet.
/*          printf("Not enough read to check the complete message.\n"); */
	  return(GIVE_UP); /* Let's not return until more byte are available */
	  }

  /* There is enough data to make a packet. Transfer over the data. */
  for(i=0;i<incoming_command.data_length;i++)
    incoming_command.data[i]=PeekByte();

  //Now move over the CRC.
  incoming_command.CRC.as_bytes[0]=PeekByte();
  incoming_command.CRC.as_bytes[1]=PeekByte();
  //Now check the CRC.

  //Compute the expected CheckSum
  testcrc = get_crc((unsigned char *)&incoming_command,
		  incoming_command.data_length+2, 0xFFFF);
  testcrc = testcrc & 0xFFFF; /* This is TRICKY */

  if(incoming_command.CRC.as_word==testcrc)
    {
    //This is a good packet. I'll be horn swaggled. Remove the packet
    //from the serial buffer.
    AcceptPeekedData();
    //Let our caller know that incoming_command has good stuff in it.
/*    print_packet(&outgoing_response); */

    return(GOOD_MSG);
    }

  /* The CRC did not match. Toss out one byte of garbage.
   * Next pass through should re-sync.
   */
  tossed++;
  DiscardGetByte();
/*  printf("###: Wrong CheckSum. computed/real %04x:%04x \n",
  		testcrc, incoming_command.CRC.as_word); */
  return(TRY_AGAIN);
  }
//============================================================================

/* I should use the value GIVE_UP and not reenter if there is no extra
 * byte readed from the serial port
 */ 
int test_packet(int fd)
{
int is_msg;

is_msg=check_for_packet(fd, MAX_DATA_LENGTH);
while (is_msg!=GIVE_UP) {
	if (is_msg==GOOD_MSG) {
		if (incoming_command.command==0x80) {
			treat_packet();
		}
		else {
			sensors_packet(fd);
		}
	}
	is_msg=check_for_packet(fd, MAX_DATA_LENGTH);
}

return 1;
}
//============================================================================

/*
 * This is a debuging function.
 * It should be removed or compiled in conditionaly.
 * Currently it is still using printf for debuging.
 */

void print_packet(COMMAND_PACKET *packet)
{
  int i, cmd, top, len; 

  top=(0xC0&(packet->command)) >> 6;
  cmd=(0x3F&(packet->command));
  len=packet->data_length;

  printf("Message (%d,%d|0x%x) %d [", top, cmd, packet->command, len);

  //There is enough data to make a packet. Transfer over the data.
  for(i=0;i<packet->data_length;i++)
    printf(" %02x", packet->data[i]);
  
  printf(" ] %02x %02x .\n", packet->CRC.as_bytes[0], packet->CRC.as_bytes[1]);
}

//============================================================================

